# agregacia a kreslenie grafov

import json
import datetime
import sys
import operator
from wordcloud import WordCloud
import matplotlib.pyplot as plt
from palettable.colorbrewer.sequential import Blues_8
import matplotlib.dates

persons = ["BarackObama"]#, "BorisJohnson", "DalaiLama", "elonmusk", "GretaThunberg", "HillaryClinton", "MichelleObama", "Oprah"]

timeline = {}
hashtags = {}
extremes = {}

class maxRetweet():
	date = None
	count = None
	def __init__(self):
		self.date = None
		self.count = 0

def stackedBar():
	N = 8
	fav = []
	ret  =[]
	for person in persons:
		fav.append(extremes[person]["maxFav"].count)
		ret.append(extremes[person]["maxRet"].count)
		print(extremes[person]["maxFav"].date)
		print(extremes[person]["maxFav"].count)
	
	ind = range(0,8)    
	width = 0.35       

	p1 = plt.bar(ind, fav, width)
	p2 = plt.bar(ind, ret, width,
             bottom=fav)

	plt.ylabel('Counts')

	plt.xticks(ind, persons)
	
	plt.legend((p1[0], p2[0]), ('Favorite', 'Retweet'))

	plt.show()
def wordCloud(hashtags):
	wc = WordCloud(background_color="black",width=1000,height=1000, max_words=10,relative_scaling=0.5,normalize_plurals=False, colormap="Blues").generate_from_frequencies(hashtags)
	plt.imshow(wc)
	plt.axis("off")
	plt.margins(x=0, y=0)
	plt.show()

def pieChart(pos, neg, net):
	my_circle=plt.Circle( (0,0), 0.7, color='white')
	plt.pie([pos, neg, net], labels=("positive", "negative", "neutral"), colors=["#2585B0", "#00294C", "#EC9929"])
	p=plt.gcf()
	p.gca().add_artist(my_circle)
	plt.show()

def stackedPlot(timeline):
	print(timeline)
	x = []
	for key in timeline.keys():
		x.append(datetime.datetime.strptime(key, '%m-%Y'))
	
	y=[ [timeline[x]['positive'] for x in timeline], [timeline[x]['negative'] for x in timeline], [timeline[x]['neutral'] for x in timeline] ]

	
	plt.stackplot(matplotlib.dates.date2num(x),y, labels=['Positive','Negative','Neutral'], colors=["#2585B0", "#00294C", "#EC9929"], alpha=0.4 )
	plt.legend(loc='upper left')
	plt.gca().xaxis.set_major_locator(matplotlib.dates.AutoDateLocator())
	plt.gca().xaxis.set_major_formatter(matplotlib.dates.DateFormatter("%m-%Y"))
	plt.show()
 

for person in persons:
	file = open(person + 'New.json')
	tweets = json.load(file)
	timeline[person] = {}
	hashtags[person] = {}
	extremes[person] = {}
	extremes[person]["maxRet"] = maxRetweet()
	extremes[person]["maxFav"] = maxRetweet()

	for tweet in tweets:
		for hashtag in tweet["hashtags"]:
			if hashtag not in hashtags[person]:
				hashtags[person][hashtag] = 1
			else:
				hashtags[person][hashtag] += 1
		
		dateObj = datetime.datetime.strptime(tweet["date"], "%Y-%m-%d")
		
		dateKey = str(dateObj.month) + '-' + str(dateObj.year)
		if dateKey == "12-2019":
			continue

		if dateKey not in timeline[person].keys():
			timeline[person][dateKey] = {}
			timeline[person][dateKey]["retweets"] = 0
			timeline[person][dateKey]["favorite"] = 0
			timeline[person][dateKey]["positive"] = 0
			timeline[person][dateKey]["neutral"] = 0
			timeline[person][dateKey]["negative"] = 0
			timeline[person][dateKey]["count"] = 0

		if tweet["retweetCount"] > extremes[person]["maxRet"].count:
			extremes[person]["maxRet"].count = tweet["retweetCount"]	
			extremes[person]["maxRet"].date = tweet["date"]

		if tweet["favoriteCount"] > extremes[person]["maxFav"].count:
			extremes[person]["maxFav"].count = tweet["favoriteCount"]
			extremes[person]["maxFav"].date = tweet["date"]

		timeline[person][dateKey]["retweets"] += tweet["retweetCount"]
		timeline[person][dateKey]["favorite"] += tweet["favoriteCount"]
		sentiment = tweet["sentiment"]

		if sentiment < -0.2:
			timeline[person][dateKey]["negative"] += 1
		elif sentiment > 0.2:
			timeline[person][dateKey]["positive"] += 1
		else:
			timeline[person][dateKey]["neutral"] += 1	
		timeline[person][dateKey]["count"] += 1

	negative = 0
	positive = 0
	neutral = 0
	for element in timeline[person]:
		print(element)
		print(timeline[person][element])
		negative += timeline[person][element]["negative"]
		neutral += timeline[person][element]["neutral"]
		positive += timeline[person][element]["positive"]

	sorted_x = sorted(hashtags[person].items(), key=operator.itemgetter(1))

	for element in sorted_x:
		print(element)

	stackedPlot(timeline[person])

	wordCloud(hashtags[person])

	pieChart(positive, negative, neutral)

	
stackedBar()
sys.exit(0)
#Barack
"\"No one is born hating another person because of the color of his skin or his background or his religion...\" https://t.co/InZ58zkoAm"
#BoJo
"The fires ravaging the Amazon rainforest are not only heartbreaking, they are an international crisis. We stand ready to provide whatever help we can to bring them under control and help protect one of Earth’s greatest wonders."
#DalaiLama
"Although I am a Buddhist monk, I am skeptical that prayers alone will achieve world peace. We need instead to be enthusiastic and self-confident in taking action."

